﻿using SharpChat.Packet;
using System;
using System.Text.Json.Serialization;

namespace SharpChat.Events {
    public class UserDisconnectEvent : IChatEvent {

        [JsonIgnore]
        public DateTimeOffset DateTime { get; set; }

        [JsonIgnore]
        public ChatUser Sender { get; set; }

        [JsonIgnore]
        public string ChannelName { get; set; }

        [JsonIgnore]
        public ChatMessageFlags Flags { get; set; } = ChatMessageFlags.Log;

        [JsonIgnore]
        public long SequenceId { get; set; }

        [JsonPropertyName("reason")]
        public UserDisconnectReason Reason { get; set; }

        public UserDisconnectEvent() { }
        public UserDisconnectEvent(DateTimeOffset parted, ChatUser user, ChatChannel channel, UserDisconnectReason reason) {
            DateTime = parted;
            Sender = user;
            ChannelName = channel.Name;
            Reason = reason;
        }
    }
}
